Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultEditableFeatureAttributeDescriptor.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultEditableFeatureAttributeDescriptor.java	(revision 41637)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultEditableFeatureAttributeDescriptor.java	(revision 41638)
@@ -269,6 +269,20 @@
         this.dateFormat = dateFormat;
         return this;
     }
+
+    public EditableFeatureAttributeDescriptor setIsIndexed(boolean isIndexed) {
+        this.indexed = isIndexed;
+        return this;
+    }
     
+    public EditableFeatureAttributeDescriptor setAllowIndexDuplicateds(boolean allowDuplicateds) {
+        this.allowIndexDuplicateds = allowDuplicateds;
+        return this;
+    }
+
+    public EditableFeatureAttributeDescriptor setIsIndexAscending(boolean ascending) {
+        this.isIndexAscending = ascending;
+        return this;
+    }
     
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureAttributeDescriptor.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureAttributeDescriptor.java	(revision 41637)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.impl/src/main/java/org/gvsig/fmap/dal/feature/impl/DefaultFeatureAttributeDescriptor.java	(revision 41638)
@@ -84,6 +84,9 @@
     protected boolean isTime = false;
     protected FeatureAttributeGetter featureAttributeGetter = null;
     protected FeatureAttributeEmulator featureAttributeEmulator = null;
+    protected boolean indexed = false;
+    protected boolean isIndexAscending = true;
+    protected boolean allowIndexDuplicateds = true;
 
     protected DefaultFeatureAttributeDescriptor() {
         this.allowNull = true;
@@ -141,6 +144,9 @@
         this.isAutomatic = other.isAutomatic;
         this.isTime = other.isTime;
         this.featureAttributeEmulator = other.featureAttributeEmulator;
+        this.indexed = other.indexed;
+        this.isIndexAscending = other.isIndexAscending;
+        this.allowIndexDuplicateds = other.allowIndexDuplicateds;
     }
 
     public String getDataTypeName() {
@@ -646,6 +652,18 @@
         return this.featureAttributeEmulator;
     }
 
+    public boolean isIndexed() {
+        return this.indexed;
+    }
+
+    public boolean allowIndexDuplicateds() {
+        return this.allowIndexDuplicateds;
+    }
+
+    public boolean isIndexAscending() {
+        return this.isIndexAscending;
+    }
+
     private class ConstantValueEvaluator extends AbstractEvaluator {
         public Object evaluate(EvaluatorData data) throws EvaluatorException {
             return defaultValue;
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCServerExplorer.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCServerExplorer.java	(revision 41637)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCServerExplorer.java	(revision 41638)
@@ -31,6 +31,7 @@
 import java.util.ArrayList;
 import java.util.Iterator;
 import java.util.List;
+import org.apache.commons.lang3.StringUtils;
 
 import org.slf4j.Logger;
 import org.slf4j.LoggerFactory;
@@ -51,7 +52,6 @@
 import org.gvsig.fmap.dal.feature.EditableFeatureType;
 import org.gvsig.fmap.dal.feature.FeatureAttributeDescriptor;
 import org.gvsig.fmap.dal.feature.FeatureType;
-import org.gvsig.fmap.dal.feature.NewFeatureStoreParameters;
 import org.gvsig.fmap.dal.resource.spi.ResourceProvider;
 import org.gvsig.fmap.dal.serverexplorer.db.spi.AbstractDBServerExplorer;
 import org.gvsig.fmap.dal.spi.DataManagerProviderServices;
@@ -438,8 +438,81 @@
 		return edType;
 
 	}
+        
+        protected List createGrantStatements(String tableName, String privilege, String theRoles) {
+            List statements = new ArrayList();
+            String[] roles = StringUtils.split(theRoles,",");
+            for( int i=0; i<roles.length; i++) {
+                String statement = "GRANT "+ privilege + "ON TABLE " + tableName + " TO " + roles[i];
+                statements.add(statement);
+            }
+            return statements;
+        } 
+        
+        protected List getPermissionsSQLs(JDBCNewStoreParameters ndsp) {
+            List statements = null;
+            String roles;
+            
+            roles = ndsp.getSelectRole();
+            if( roles!=null ) {
+                if( statements == null ) {
+                    statements = new ArrayList();
+                }
+                statements.addAll(this.createGrantStatements(ndsp.tableID(), "SELECT", roles));
+            }
+            roles = ndsp.getInsertRole();
+            if( roles!=null ) {
+                if( statements == null ) {
+                    statements = new ArrayList();
+                }
+                statements.addAll(this.createGrantStatements(ndsp.tableID(), "INSERT", roles));
+            }
+            roles = ndsp.getUpdateRole();
+            if( roles!=null ) {
+                if( statements == null ) {
+                    statements = new ArrayList();
+                }
+                statements.addAll(this.createGrantStatements(ndsp.tableID(), "UPDATE", roles));
+            }
+            roles = ndsp.getDeleteRole();
+            if( roles!=null ) {
+                if( statements == null ) {
+                    statements = new ArrayList();
+                }
+                statements.addAll(this.createGrantStatements(ndsp.tableID(), "DELETE", roles));
+            }
+            roles = ndsp.getTruncateRole();
+            if( roles!=null ) {
+                if( statements == null ) {
+                    statements = new ArrayList();
+                }
+                statements.addAll(this.createGrantStatements(ndsp.tableID(), "TRUNCATE", roles));
+            }
+            roles = ndsp.getReferenceRole();
+            if( roles!=null ) {
+                if( statements == null ) {
+                    statements = new ArrayList();
+                }
+                statements.addAll(this.createGrantStatements(ndsp.tableID(), "REFERENCE", roles));
+            }
+            roles = ndsp.getTriggerRole();
+            if( roles!=null ) {
+                if( statements == null ) {
+                    statements = new ArrayList();
+                }
+                statements.addAll(this.createGrantStatements(ndsp.tableID(), "TRIGGER", roles));
+            }
+            roles = ndsp.getAllRole();
+            if( roles!=null ) {
+                if( statements == null ) {
+                    statements = new ArrayList();
+                }
+                statements.addAll(this.createGrantStatements(ndsp.tableID(), "ALL", roles));
+            }
+            
+            return statements;
+        }
 
-
 	public boolean add(String providerName, NewDataStoreParameters ndsp, boolean overwrite)
 			throws DataException {
 
@@ -512,9 +585,17 @@
 		sql.append(")");
 
 		final String sqlCreate = sql.toString();
-		final List sqlAdditional = helper
-				.getAdditionalSqlToCreate(ndsp, fType);
+		final List sqlAdditional = helper.getAdditionalSqlToCreate(ndsp, fType);
 
+                List permissions = getPermissionsSQLs((JDBCNewStoreParameters) ndsp);
+                if( permissions != null ) {
+                    sqlAdditional.addAll(permissions);
+                }
+                
+                if( ((JDBCNewStoreParameters) ndsp).getPostCreatingStatement()!=null ) {
+                    sqlAdditional.add(((JDBCNewStoreParameters) ndsp).getPostCreatingStatement());
+                }
+                
 		TransactionalAction action = new TransactionalAction() {
 
 			public boolean continueTransactionAllowed() {
@@ -578,5 +659,9 @@
 		x.add(JDBCStoreProvider.NAME);
 		return x;
 	}
+        
+        public void updateTableStatistics(String tableName) {
+            
+        }
 
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCNewStoreParameters.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCNewStoreParameters.java	(revision 41637)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.db/org.gvsig.fmap.dal.db.jdbc/src/main/java/org/gvsig/fmap/dal/store/jdbc/JDBCNewStoreParameters.java	(revision 41638)
@@ -22,6 +22,7 @@
  */
 package org.gvsig.fmap.dal.store.jdbc;
 
+import org.apache.commons.lang3.StringUtils;
 import org.gvsig.fmap.dal.feature.EditableFeatureType;
 import org.gvsig.fmap.dal.feature.FeatureType;
 import org.gvsig.fmap.dal.feature.NewFeatureStoreParameters;
@@ -113,4 +114,56 @@
         return "\"".concat(name).concat("\"");
     }
 
+    public String getSelectRole() {
+        String value = (String) this.getDynValue("SelectRole");
+        return StringUtils.defaultIfBlank(value, null);
+    }
+    
+    public String getInsertRole() {
+        String value = (String) this.getDynValue("InsertRole");
+        return StringUtils.defaultIfBlank(value, null);
+    }
+    
+    
+    public String getUpdateRole() {
+        String value = (String) this.getDynValue("UpdateRole");
+        return StringUtils.defaultIfBlank(value, null);
+    }
+    
+    
+    public String getDeleteRole() {
+        String value = (String) this.getDynValue("DeleteRole");
+        return StringUtils.defaultIfBlank(value, null);
+    }
+    
+    
+    public String getTruncateRole() {
+        String value = (String) this.getDynValue("TruncateRole");
+        return StringUtils.defaultIfBlank(value, null);
+    }
+    
+    
+    public String getReferenceRole() {
+        String value = (String) this.getDynValue("ReferenceRole");
+        return StringUtils.defaultIfBlank(value, null);
+    }
+    
+    
+    public String getTriggerRole() {
+        String value = (String) this.getDynValue("TriggerRole");
+        return StringUtils.defaultIfBlank(value, null);
+    }
+    
+    
+    public String getAllRole() {
+        String value = (String) this.getDynValue("AllRole");
+        return StringUtils.defaultIfBlank(value, null);
+    }
+    
+    
+    public String getPostCreatingStatement() {
+        String value = (String) this.getDynValue("PostCreatingStatement");
+        return StringUtils.defaultIfBlank(value, null);
+    }
+    
 }
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/EditableFeatureAttributeDescriptor.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/EditableFeatureAttributeDescriptor.java	(revision 41637)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/EditableFeatureAttributeDescriptor.java	(revision 41638)
@@ -236,6 +236,17 @@
 	 */
 	public EditableFeatureAttributeDescriptor setIsTime(boolean isTime);
 	
+        /**
+         * Sets if this attribute is indexed in the table.
+         * @param isIndexed
+         * @return  this
+         */
+        public EditableFeatureAttributeDescriptor setIsIndexed(boolean isIndexed);
+        
+        public EditableFeatureAttributeDescriptor setAllowIndexDuplicateds(boolean allowDuplicateds);
+        
+        public EditableFeatureAttributeDescriptor setIsIndexAscending(boolean ascending);
+        
 	/**
 	 * Returns the attribute descriptor's name before
 	 * it was changed or null if never changed 
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/FeatureAttributeDescriptor.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/FeatureAttributeDescriptor.java	(revision 41637)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.dal/org.gvsig.fmap.dal.api/src/main/java/org/gvsig/fmap/dal/feature/FeatureAttributeDescriptor.java	(revision 41638)
@@ -201,6 +201,15 @@
 	 */
 	public boolean isTime();  
 
+        /**
+         * Return true if the attribute has and index in the table.
+         * 
+         * @return true if indexed.
+         */
+        public boolean isIndexed();
+        public boolean allowIndexDuplicateds();
+        public boolean isIndexAscending();
+        
 	/**
 	 * Gets if the attribute has a {@link FeatureAttributeGetter}.
 	 * @return
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.mapcontext/org.gvsig.fmap.mapcontext.api/src/test/java/org/gvsig/fmap/mapcontext/persistence/DummyFileFeatureStore.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.mapcontext/org.gvsig.fmap.mapcontext.api/src/test/java/org/gvsig/fmap/mapcontext/persistence/DummyFileFeatureStore.java	(revision 41637)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.compat.cdc/org.gvsig.fmap.mapcontext/org.gvsig.fmap.mapcontext.api/src/test/java/org/gvsig/fmap/mapcontext/persistence/DummyFileFeatureStore.java	(revision 41638)
@@ -417,6 +417,18 @@
         public FeatureAttributeEmulator getFeatureAttributeEmulator() {
             return null;
         }
+
+        public boolean isIndexed() {
+            throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
+        }
+
+        public boolean allowIndexDuplicateds() {
+            throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
+        }
+
+        public boolean isIndexAscending() {
+            throw new UnsupportedOperationException("Not supported yet."); //To change body of generated methods, choose Tools | Templates.
+        }
 	}
 
 	public static class DummyFeatureType implements FeatureType {
Index: trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/GeometryIndexPanel.java
===================================================================
--- trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/GeometryIndexPanel.java	(revision 0)
+++ trunk/org.gvsig.desktop/org.gvsig.desktop.library/org.gvsig.exportto/org.gvsig.exportto.swing/org.gvsig.exportto.swing.prov/org.gvsig.exportto.swing.prov.jdbc/src/main/java/org/gvsig/exportto/swing/prov/jdbc/panel/GeometryIndexPanel.java	(revision 41638)
@@ -0,0 +1,63 @@
+
+package org.gvsig.exportto.swing.prov.jdbc.panel;
+
+import javax.swing.JComponent;
+import org.gvsig.exportto.swing.prov.jdbc.ExporttoJDBCOptions;
+import org.gvsig.exportto.swing.spi.ExporttoPanelValidationException;
+import org.gvsig.exportto.swing.spi.ExporttoSwingProviderPanel;
+import org.gvsig.fmap.dal.exception.DataException;
+import org.gvsig.tools.ToolsLocator;
+import org.gvsig.tools.i18n.I18nManager;
+import org.slf4j.Logger;
+import org.slf4j.LoggerFactory;
+
+
+public class GeometryIndexPanel extends GeometryIndexPanelLayout implements ExporttoSwingProviderPanel {
+    private static final long serialVersionUID = -3995015914295698209L;
+    
+    private static final Logger logger = LoggerFactory.getLogger(GeometryIndexPanel.class);
+
+    private ExporttoJDBCOptions provider;
+
+    public GeometryIndexPanel(ExporttoJDBCOptions provider) {
+        this.provider = provider;
+        initComponents();
+    }
+
+    private void initComponents() {
+        int index = -1;
+        try {
+            index = this.provider.getSource().getDefaultFeatureType().getDefaultGeometryAttributeIndex();
+        } catch (DataException ex) {
+            logger.warn("Problems determining if the tabla has a geometry column",ex);
+        }
+        if( index <0 ) {
+            this.chkCreateGeometryIndex.setEnabled(false);
+            this.chkCreateGeometryIndex.setSelected(false);
+        } else {
+            this.chkCreateGeometryIndex.setEnabled(true);
+            this.chkCreateGeometryIndex.setSelected(true);
+        }
+    }
+
+    public String getPanelTitle() {
+        I18nManager i18nManager = ToolsLocator.getI18nManager();
+        return i18nManager.getTranslation("Create_geometry_index");    
+    }
+
+    public boolean isValidPanel() throws ExporttoPanelValidationException {
+        return true;
+    }
+    
+    public void enterPanel() {
+        // Default do nothing
+    }
+    
+    public JComponent asJComponent() {
+        return this;
+    }
+
+    public boolean getCreateIndexInGeometryRow() {
+        return this.chkCreateGeometryIndex.isSelected();
+    }
+}
